#!/usr/bin/env python

from collections import defaultdict

############# TOP-DOWN LCS #############

def LCS_MEMOIZE(X, Y, C):
    key = (len(X), len(Y))
    if key not in C:
        if len(X) == 0 or len(Y) == 0:
            C[key] = []
        else:
            if X[-1] == Y[-1]:
                C[key] = LCS_MEMOIZE(X[:-1], Y[:-1], C) + [ X[-1] ]
            else:
                C[key] = max(LCS_MEMOIZE(X[:-1], Y ,C),
                LCS_MEMOIZE (X, Y[:-1], C), key=len )
    return C[key]
    

if __name__ == "__main__":
    X = "AATCC"
    Y = "ACACG"
    m = len(X)
    n = len(Y)
    C = defaultdict(lambda: 0)
    lcs = "".join(LCS_MEMOIZE(X,Y,C))
    print "LCS length :: %s" % (len(lcs))
    print "A possible LCS :: %s" % (lcs)
